/* Edita categoria */
package servlets;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import beans.Categoria;

import dbclass.CategoriaDAO;
import dbclass.CategoriaJDBC;

/**
 * Servlet implementation class CategoriasEdit
 */
public class CategoriasEdit extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public CategoriasEdit() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession(true);
		//Verifica login
		if(session.getValue("autor_login") == null) {
			response.sendRedirect("Home?msg_erro=Acesso Negado");  return;
		} 
		
		
		CategoriaDAO categoriaDAO = new CategoriaJDBC(); 
		int id = Integer.parseInt(request.getParameter("id"));
		try {
			Categoria categoria = categoriaDAO.findById(id);
			session.setAttribute("categoria", categoria);    
			String url="/CategoriaEdit.jsp";  
			ServletContext sc = getServletContext();
			RequestDispatcher rd = sc.getRequestDispatcher(url);
			rd.forward(request, response);    
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		HttpSession session = request.getSession(true);
		String url = null;
		
		CategoriaDAO categoriaDAO = new CategoriaJDBC();
		
		int id = Integer.parseInt(request.getParameter("id"));	 
		String nome = request.getParameter("nome");  
		Categoria cat = new Categoria(id, nome);
		
		try { 
				 
			categoriaDAO.update(cat); 
			url="Categorias?msg_sucesso=Categoria editada com sucesso";   
 
			response.sendRedirect(url); 
		} catch (ClassNotFoundException e) {   
			// TODO Auto-generated catch block 
			e.printStackTrace(); 
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
	}

}
