/* Homepage do site: lista noticias */
package servlets;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import beans.Categoria;
import beans.Noticia;
import dbclass.CategoriaDAO;
import dbclass.CategoriaJDBC;
import dbclass.NoticiaDAO;
import dbclass.NoticiaJDBC;
import dbclass.VotoDAO;
import dbclass.VotoJDBC;

/**
 * Servlet implementation class Noticias
 */
public class Home extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public Home() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession(true);
		
		NoticiaDAO noticiaDAO = new NoticiaJDBC();
		CategoriaDAO categoriaDAO = new CategoriaJDBC();
		
		String id = (String)request.getParameter("id"); 
		 
		java.util.List<Noticia> noticias = null;  	
		java.util.List<Categoria> categorias = null;   
		
		try {  
			if(id != "" && id != null ) {
				noticias = noticiaDAO.findAll((long)Integer.parseInt(id));
				Categoria cat = categoriaDAO.findById((long)Integer.parseInt(id));
				session.setAttribute("nome_categoria", cat.getNome());   
			} 
			else {
				noticias = noticiaDAO.findAll();
				session.setAttribute("nome_categoria", "");  
			}
			categorias = categoriaDAO.findAll();    
		} catch (SQLException e) {
			// TODO Auto-generated catch block 
			e.printStackTrace();   
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block 
			e.printStackTrace(); 
		}
		session.setAttribute("noticias", noticias);  
		session.setAttribute("categorias", categorias);
		
		String url="/Home.jsp";   
		ServletContext sc = getServletContext();
		RequestDispatcher rd = sc.getRequestDispatcher(url);
		rd.forward(request, response); 
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	}

}
