/*
 * Lista as noticias mais votadas
 * */

package servlets;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import beans.Categoria;
import beans.Noticia;
import dbclass.CategoriaDAO;
import dbclass.CategoriaJDBC;
import dbclass.NoticiaDAO;
import dbclass.NoticiaJDBC;
import dbclass.VotoDAO;
import dbclass.VotoJDBC;

/**
 * Servlet implementation class MaisVotadas
 */
public class MaisVotadas extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public MaisVotadas() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession(true);

		
		VotoDAO votoDAO = new VotoJDBC();
		 
		ResultSet noticias = null;  	

		try {  
			noticias = votoDAO.maisVotadas();  
		} catch (SQLException e) {
			// TODO Auto-generated catch block 
			e.printStackTrace();   
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block 
			e.printStackTrace(); 
		}
		session.setAttribute("noticias", noticias);  
		
		String url="/MaisVotadas.jsp";   
		ServletContext sc = getServletContext();
		RequestDispatcher rd = sc.getRequestDispatcher(url);
		rd.forward(request, response); 
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	}

}
