/*
 * Lista as noticias para edicao
 * */
package servlets;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import beans.Categoria;
import beans.Noticia;
import dbclass.CategoriaDAO;
import dbclass.CategoriaJDBC;
import dbclass.NoticiaDAO;
import dbclass.NoticiaJDBC;

/**package servlets;
 * Servlet implementation class Noticias
 */
public class Noticias extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public Noticias() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession(true);
		//Verifica login
		if(session.getValue("autor_login") == null) {
			response.sendRedirect("Home?msg_erro=Acesso Negado");  return;
		} 
		
		
		NoticiaDAO noticiaDAO = new NoticiaJDBC();
		CategoriaDAO categoriaDAO = new CategoriaJDBC();
		
		String action = (String)request.getParameter("action"); 
		session.setAttribute("action", action); 
		 
		java.util.List<Noticia> noticias = null;  	
		java.util.List<Categoria> categorias = null;   
		
		try {  
			noticias = noticiaDAO.findAll(); 
			categorias = categoriaDAO.findAll();    
		} catch (SQLException e) {
			// TODO Auto-generated catch block 
			e.printStackTrace();   
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block 
			e.printStackTrace(); 
		}
		session.setAttribute("noticias", noticias);  
		session.setAttribute("categorias", categorias);
		
		String url="/Noticia.jsp";   
		ServletContext sc = getServletContext();
		RequestDispatcher rd = sc.getRequestDispatcher(url);
		rd.forward(request, response); 
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	}

}
