/*
 * Edita noticia
 * */

package servlets;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import beans.Autor;
import beans.Noticia;
import beans.Tag;
import dbclass.NoticiaDAO;
import dbclass.NoticiaJDBC;
import dbclass.TagDAO;
import dbclass.TagJDBC;

/**
 * Servlet implementation class NoticiasEdit
 */
public class NoticiasEdit extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public NoticiasEdit() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession(true);
		//Verifica login
		if(session.getValue("autor_login") == null) {
			response.sendRedirect("Home?msg_erro=Acesso Negado");  return;
		} 

		NoticiaDAO noticiaDAO = new NoticiaJDBC(); 
		int id = Integer.parseInt(request.getParameter("id"));
		try {
			Noticia noticia = noticiaDAO.findById(id);
			session.setAttribute("noticia", noticia);    
			String url="/NoticiaEdit.jsp";    
			ServletContext sc = getServletContext();
			RequestDispatcher rd = sc.getRequestDispatcher(url);
			rd.forward(request, response);    
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		HttpSession session = request.getSession(true);
		String url = null;
		Autor autor = (Autor) session.getAttribute("autor_login");
		
		
		NoticiaDAO noticiaDAO = new NoticiaJDBC(); 
		
		int id = Integer.parseInt(request.getParameter("id"));	 
		String titulo = request.getParameter("titulo");
		String corpo = request.getParameter("corpo");
		String data = request.getParameter("data");
		long id_categoria = (long)Integer.parseInt(request.getParameter("id_categoria"));
		long id_autor = autor.getId();
		
		
		Noticia noticia = new Noticia(id, titulo, corpo, data, id_autor, id_categoria);
		noticia.setData(noticia.data_yyyymmdd());
		
		try {  
		    //Apaga todas as tags e depois adiciona
			//Mais simples do que verificar se ja existe e adicionar, caso contrario
			TagDAO tagdao = new TagJDBC();
			tagdao.deleteAll((long)id); 
			
			//Adicionar Tags
			String tags =  request.getParameter("tags");
			if(tags != null) {
					
				String[] array_tags = tags.split(",");
		
				if(array_tags.length > 0) {
					
					for(int i = 0; i < array_tags.length; i++){
						Tag tag = new Tag(array_tags[i],id);
						tagdao.insert(tag);	 
					}
				}
			}
			
			noticiaDAO.update(noticia); 
			url="Noticias?msg_sucesso=Noticia editado com sucesso";   
 
			response.sendRedirect(url); 
		} catch (ClassNotFoundException e) {    
			// TODO Auto-generated catch block 
			e.printStackTrace();  
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
	}

}
