/*
 * Gerencia imagens de uma noticia
 * */
package servlets;

import java.io.IOException;
import java.sql.SQLException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import beans.Imagem;
import dbclass.ImagemDAO;
import dbclass.ImagemJDBC;

/**
 * Servlet implementation class NoticiasImagens
 */
public class NoticiasImagens extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public NoticiasImagens() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession(true);
		//Verifica login
		if(session.getValue("autor_login") == null) {
			response.sendRedirect("Home?msg_erro=Acesso Negado");  return;
		} 
	
		
		ImagemDAO fotoDAO = new ImagemJDBC(); 
		
		int id = Integer.parseInt(request.getParameter("id")); 
		session.setAttribute("id_noticia", id);  
		
		List<Imagem> imagensUsadas = null;  //Imagens que ja estao relacionadas a noticia
		List<Imagem> imagensNaoUsadas = null;  //Imagens nao relacionadas a noticia
		
		try {
			imagensUsadas = fotoDAO.findUsadas((long)id);   
			imagensNaoUsadas= fotoDAO.findNaoUsadas((long)id);    
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace(); 
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block 
			e.printStackTrace(); 
		}
		session.setAttribute("imagensUsadas", imagensUsadas);  
		session.setAttribute("imagensNaoUsadas", imagensNaoUsadas);  
		
		 
		String url="/NoticiasImagens.jsp";    
		ServletContext sc = getServletContext();
		RequestDispatcher rd = sc.getRequestDispatcher(url);
		rd.forward(request, response);    
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	}

}
